// Tester.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "ShipList.h"

int main(int argc, char* argv[])
{
	ShipList	masterList;
	ShipList	workList;

	printf("Hello World!\n");

	DWORD			beginTick,
					endTick;
	char			foo[8];
	ShipList::eGame	which;

	srand(GetTickCount());

	printf("1: EAW\n");
	printf("2: OP\n");
	printf("\n");
	printf("Which? ");
	gets(foo);
	
	if (atoi(foo) == 1) which = ShipList::kEmpiresAtWar;
	else				which = ShipList::kOrionPirates;

	beginTick = GetTickCount();	
	if (!masterList.CreateMaster(which, false))
		printf("\n\nCould not read the shiplist files.\n"), exit(1);
	endTick = GetTickCount();

	printf("\n\nTotal parsing took %d milliseconds!\n", endTick - beginTick);

	beginTick = GetTickCount();	
	workList = masterList;
	endTick = GetTickCount();
	
	printf("\n\nCopying list to another list took %d milliseconds!  Count is %d.\n", endTick - beginTick, workList.size());

	std::list< eRace >	raceList;
	raceList.push_back(kOrion);

	beginTick = GetTickCount();	
	int32 newcount = workList.Subset(raceList);						// limit to Orions
	endTick = GetTickCount();

	printf("\n\nLimiting to Orions took %d milliseconds, new count is %d!\n", endTick - beginTick, newcount);

	std::list< eHullType >	hullList;
	hullList.push_back(kFF);
	hullList.push_back(kCL);
	hullList.push_back(kDN);

	beginTick = GetTickCount();	
	newcount = workList.Subset(hullList);							// limit to FF, CL, DN
	endTick = GetTickCount();

	printf("\n\nLimiting to FF,CL,DN took %d milliseconds, new count is %d!\n", endTick - beginTick, newcount);

	beginTick = GetTickCount();	
	newcount = workList.Subset(ShipList::kSubsetBPV, 120, 150);		// limit to 120-150 bpv
	endTick = GetTickCount();

	printf("\n\nLimiting to 120-150 bpv took %d milliseconds, new count is %d!\n\n\n", endTick - beginTick, newcount);

	for (int i = 0; i < 10; i++)
	{
		Ship s;
		if (workList.SelectRandomShip(s))
			printf("Random choice %d: %s\n", i, s.shipCode.c_str());
		else
			printf("Random choice <no ships found>\n");
	}

	beginTick = GetTickCount();	
	ShipList newFleet = workList.CreateFleet(3, 450);				// 3 ships, 450 bpv total
	endTick = GetTickCount();

	printf("\n\nCreateFleet selection took %d milliseconds, resulting in a fleet with:\n\t%d ships\n\t%d total bpv\n\n", endTick - beginTick, newFleet.size(), newFleet.TotalBPV());
	
	int k = 1;
	for (RealShipListIter iter = newFleet.begin(); iter != newFleet.end(); iter++, k++)
		printf("Ship #%d: %s\n", k, iter->shipCode.c_str());

	return 1;
}

